Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions

# GraphicsStateGuardian Class Reference

Encapsulates all the communication with a particular instance of a given rendering backend. More...

Inheritance diagram for GraphicsStateGuardian:

List of all members.

## Public Types
enum | ShaderModel { SM00 = 0, SM11 = 1, SM20 = 2, SM2X = 3, SM30 = 4, SM40 = 5 }
## Public Member Functions
bool | beginScene ()
| Called between begin_frame() and end_frame() to mark the beginning of drawing commands for a "scene" (usually a particular DisplayRegion) within a frame.
| clearFlashTexture ()
| Resets the "flash texture", so that no textures will flash.
| endScene ()
| Called between begin_frame() and end_frame() to mark the end of drawing commands for a "scene" (usually a particular DisplayRegion) within a frame.
bool | getAlphaScaleViaTexture ()
| Returns true if this particular GSG can implement (or would prefer to implement) an alpha scale via an additional Texture layer, or false if we need to actually munge the alpha.
bool | getAlphaScaleViaTexture (TextureAttrib const tex_attrib)
| This variant of get_alpha_scale_via_texture() answers the question of whether the GSG can implement an alpha scale via an additional Texture layer, considering the current TextureAttrib that will be in effect.
bool | getColorScaleViaLighting ()
| Returns true if this particular GSG can implement (or would prefer to implement) set color and/or color scale using materials and/or ambient lights, or false if we need to actually munge the color.
CoordinateSystem | getCoordinateSystem ()
| Returns the coordinate system in effect on this particular gsg.
bool | getCopyTextureInverted ()
| Returns true if this particular GSG has the property that any framebuffer-to-texture copy results in a texture that is upside-down and backwards from Panda's usual convention; that is, it copies into a texture from the bottom up instead of from the top down.
string | getDriverRenderer ()
| Returns GL_Renderer.
int | getDriverShaderVersionMajor ()
| Returns the major version of the shader model.
int | getDriverShaderVersionMinor ()
| Returns the minor version of the shader model.
string | getDriverVendor ()
| Returns the vendor of the video card driver.
string | getDriverVersion ()
| Returns driver version.
int | getDriverVersionMajor ()
| Returns major version of the video driver.
int | getDriverVersionMinor ()
| Returns the minor version of the video driver.
GraphicsEngine | getEngine ()
| Returns the graphics engine that created this GSG.
Texture | getFlashTexture ()
| Returns the current "flash texture", if any, or NULL if none.
float | getGamma (float gamma)
| Get the current gamma setting.
CoordinateSystem | getInternalCoordinateSystem ()
| Returns the coordinate system used internally by the GSG.
PandaLoader | getLoader ()
| Returns the Loader object that will be used by this GSG to load textures when necessary, if get_incomplete_render() is true.
int | getMax2dTextureArrayLayers ()
| Returns the largest possible number of pages, or -1 if there is no particular limit.
int | getMax3dTextureDimension ()
| Returns the largest possible texture size in any one dimension for a 3-d texture, or -1 if there is no particular limit.
int | getMaxClipPlanes ()
| Returns the maximum number of simultaneous clip planes that may be applied to geometry, or -1 if there is no particular limit.
int | getMaxCubeMapDimension ()
| Returns the largest possible texture size in any one dimension for a cube map texture, or -1 if there is no particular limit.
int | getMaximumSimultaneousRenderTargets ()
| Returns the maximum simultaneous render targets supported.
int | getMaxLights ()
| Returns the maximum number of simultaneous lights that may be rendered on geometry, or -1 if there is no particular limit.
int | getMaxTextureStages ()
| Returns the maximum number of simultaneous textures that may be applied to geometry with multitexturing, as supported by this particular GSG.
int | getMaxVertexTransformIndices ()
| Returns the maximum number of transforms there may be in a single TransformTable for this graphics hardware.
int | getMaxVertexTransforms ()
| Returns the maximum number of transform matrices that may be simultaneously used to transform any one vertex by the graphics hardware.
GraphicsPipe | getPipe ()
| Returns the graphics pipe on which this GSG was created.
PreparedGraphicsObjects | getPreparedObjects ()
| Returns the set of texture and geom objects that have been prepared with this GSG (and possibly other GSG's that share objects).
PyObject | getPreparedTextures ()
| Returns a Python list of all of the currently-prepared textures within the GSG.
bool | getRuntimeColorScale ()
| Returns true if this particular GSG can implement (or would prefer to implement) set color and/or color scale directly, without requiring any munging of vertices or tricks with lighting.
SceneSetup | getScene ()
| Returns the current SceneSetup object.
int | getShaderModel ()
| Returns the ShaderModel.
bool | getSupports2dTextureArray ()
| Returns true if this GSG can render 2-d textures array.
bool | getSupports3dTexture ()
| Returns true if this GSG can render 3-d (volumetric) textures.
bool | getSupportsBasicShaders ()
| Returns true if this particular GSG supports arbfp1+arbvp1 or above.
bool | getSupportsCgProfile (string name)
| Returns true if this particular GSG supports the specified Cg Shader Profile.
bool | getSupportsCompressedTexture ()
| Returns true if this GSG can compress textures as it loads them into texture memory, and/or accept pre-compressed textures for storing.
bool | getSupportsCubeMap ()
| Returns true if this GSG can render cube map textures.
bool | getSupportsDepthStencil ()
| Returns true if this particular GSG supports textures whose format is F_depth_stencil.
bool | getSupportsDepthTexture ()
| Returns true if this particular GSG supports textures whose format is F_depth_stencil.
bool | getSupportsGenerateMipmap ()
| Returns true if this particular GSG can generate mipmaps for a texture automatically, or if they must be generated in software.
bool | getSupportsGeometryInstancing ()
| Returns true if this particular GSG supports hardware geometry instancing: the ability to render multiple copies of a model.
bool | getSupportsGlsl ()
| Returns true if this particular GSG supports GLSL shaders.
bool | getSupportsStencil ()
| Returns true if this particular GSG supports stencil buffers at all.
bool | getSupportsTexNonPow2 ()
| Returns true if this GSG can handle non power of two sized textures.
bool | getSupportsTextureCombine ()
| Returns true if this particular GSG can use the TextureStage.M_combine mode, which includes all of the texture blend modes specified by set_combine_rgb() and/or set_combine_alpha().
bool | getSupportsTextureDot3 ()
| Returns true if this GSG can use the TextureStage.CM_dot3_rgb or CM_dot3_rgba combine modes.
bool | getSupportsTextureSavedResult ()
| Returns true if this GSG can use the TextureStage.CS_last_saved_result source, which allows you to save the result of a TextureStage and re-use it for multiple inputs.
bool | getSupportsTwoSidedStencil ()
| Returns true if this particular GSG supports two sided stencil: different stencil settings for the front and back side of the same polygon.
QualityLevel | getTextureQualityOverride ()
| Returns the global quality_level override specified by set_texture_quality_override.
GraphicsThreadingModel const | getThreadingModel ()
| Returns the threading model that was used to create this GSG.
bool | isActive ()
| Returns the active flag associated with the GraphicsStateGuardian.
bool | isHardware ()
| Returns true if this GSG appears to be hardware-accelerated, or false if it is known to be software only.
bool | isValid ()
| Returns true if the GSG has been correctly initialized within a graphics context, false if there has been some problem or it hasn't been initialized yet.
bool | needsReset ()
| Returns true if the gsg is marked as needing a reset.
| releaseAll ()
| Releases all prepared objects.
int | releaseAllGeoms ()
| Frees the resources for all geoms associated with this GSG.
int | releaseAllIndexBuffers ()
| Frees the resources for all index buffers associated with this GSG.
int | releaseAllTextures ()
| Frees the resources for all textures associated with this GSG.
int | releaseAllVertexBuffers ()
| Frees the resources for all vertex buffers associated with this GSG.
| restoreGamma ()
| Restore original gamma setting.
| setActive (bool active)
| Sets the active flag associated with the GraphicsStateGuardian.
| setCoordinateSystem (CoordinateSystem cs)
| Changes the coordinate system in effect on this particular gsg.
| setFlashTexture (Texture tex)
| Sets the "flash texture".
bool | setGamma (float gamma)
| Set gamma.
| setIncompleteRender (bool incomplete_render)
| Sets the incomplete_render flag.
| setLoader (PandaLoader loader)
| Sets the Loader object that will be used by this GSG to load textures when necessary, if get_incomplete_render() is true.
bool | setScene (SceneSetup scene_setup)
| Sets the SceneSetup object that indicates the initial camera position, etc.
| setShaderModel (int shader_model)
| Sets the ShaderModel.
| setTextureQualityOverride (QualityLevel quality_level)
| Specifies the global quality_level to be imposed for all Textures rendered by this GSG.
## Static Public Member Functions
static TextureStage | getAlphaScaleTextureStage ()
| Returns the TextureStage that will be used to apply an alpha scale, if get_alpha_scale_via_texture() returns true.
static TypeHandle | getClassType ()

## Detailed Description

Encapsulates all the communication with a particular instance of a given rendering backend.

Tries to guarantee that redundant state-change requests are not issued (hence "state guardian").

There will be one of these objects for each different graphics context active in the system.

## Member Enumeration Documentation

enum ShaderModel

Enumerator:

  SM00 |
  SM11 |
  SM20 |
  SM2X |
  SM30 |
  SM40 |

## Member Function Documentation

bool beginScene | ( |  | ) |

Called between begin_frame() and end_frame() to mark the beginning of drawing commands for a "scene" (usually a particular DisplayRegion) within a frame.

All 3-D drawing commands, except the clear operation, must be enclosed within begin_scene() .. end_scene(). This must be called in the draw thread.

The return value is true if successful (in which case the scene will be drawn and end_scene() will be called later), or false if unsuccessful (in which case nothing will be drawn and end_scene() will not be called).

clearFlashTexture | ( |  | ) |

Resets the "flash texture", so that no textures will flash.

See set_flash_texture().

endScene | ( |  | ) |

Called between begin_frame() and end_frame() to mark the end of drawing commands for a "scene" (usually a particular DisplayRegion) within a frame.

All 3-D drawing commands, except the clear operation, must be enclosed within begin_scene() .. end_scene().

static TextureStage getAlphaScaleTextureStage | ( |  | ) | `[static]`

Returns the TextureStage that will be used to apply an alpha scale, if get_alpha_scale_via_texture() returns true.

bool getAlphaScaleViaTexture | ( | TextureAttrib const | tex_attrib | ) |

This variant of get_alpha_scale_via_texture() answers the question of whether the GSG can implement an alpha scale via an additional Texture layer, considering the current TextureAttrib that will be in effect.

This considers whether there is at least one additional texture slot available on the GSG.

bool getAlphaScaleViaTexture | ( |  | ) |

Returns true if this particular GSG can implement (or would prefer to implement) an alpha scale via an additional Texture layer, or false if we need to actually munge the alpha.

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from GraphicsStateGuardianBase.

bool getColorScaleViaLighting | ( |  | ) |

Returns true if this particular GSG can implement (or would prefer to implement) set color and/or color scale using materials and/or ambient lights, or false if we need to actually munge the color.

CoordinateSystem getCoordinateSystem | ( |  | ) |

Returns the coordinate system in effect on this particular gsg.

Normally, this will be the default coordinate system, but it might be set differently at runtime.

bool getCopyTextureInverted | ( |  | ) |

Returns true if this particular GSG has the property that any framebuffer-to-texture copy results in a texture that is upside-down and backwards from Panda's usual convention; that is, it copies into a texture from the bottom up instead of from the top down.

If this is true, then on offscreen GraphicsBuffer created for the purposes of rendering into a texture should be created with the invert flag set true, to compensate. Panda will do this automatically if you create an offscreen buffer using GraphicsOutput.make_texture_buffer().

string getDriverRenderer | ( |  | ) |

Returns GL_Renderer.

int getDriverShaderVersionMajor | ( |  | ) |

Returns the major version of the shader model.

int getDriverShaderVersionMinor | ( |  | ) |

Returns the minor version of the shader model.

string getDriverVendor | ( |  | ) |

Returns the vendor of the video card driver.

string getDriverVersion | ( |  | ) |

Returns driver version.

int getDriverVersionMajor | ( |  | ) |

Returns major version of the video driver.

int getDriverVersionMinor | ( |  | ) |

Returns the minor version of the video driver.

GraphicsEngine getEngine | ( |  | ) |

Returns the graphics engine that created this GSG.

Since there is normally only one GraphicsEngine object in an application, this is usually the same as the global GraphicsEngine.

Texture getFlashTexture | ( |  | ) |

Returns the current "flash texture", if any, or NULL if none.

See set_flash_texture().

float getGamma | ( | float | gamma | ) |

Get the current gamma setting.

CoordinateSystem getInternalCoordinateSystem | ( |  | ) |

Returns the coordinate system used internally by the GSG.

This may be the same as the external coordinate system reported by get_coordinate_system(), or it may be something different.

In any case, vertices that have been transformed before being handed to the GSG (that is, vertices with a contents value of C_clip_point) will be expected to be in this coordinate system.

PandaLoader getLoader | ( |  | ) |

Returns the Loader object that will be used by this GSG to load textures when necessary, if get_incomplete_render() is true.

int getMax2dTextureArrayLayers | ( |  | ) |

Returns the largest possible number of pages, or -1 if there is no particular limit.

Returns 0 if 2-d texture arrays not supported.

The value returned may not be meaningful until after the graphics context has been fully created (e.g. the window has been opened).

int getMax3dTextureDimension | ( |  | ) |

Returns the largest possible texture size in any one dimension for a 3-d texture, or -1 if there is no particular limit.

Returns 0 if 3-d textures are not supported.

The value returned may not be meaningful until after the graphics context has been fully created (e.g. the window has been opened).

int getMaxClipPlanes | ( |  | ) |

Returns the maximum number of simultaneous clip planes that may be applied to geometry, or -1 if there is no particular limit.

The value returned may not be meaningful until after the graphics context has been fully created (e.g. the window has been opened).

int getMaxCubeMapDimension | ( |  | ) |

Returns the largest possible texture size in any one dimension for a cube map texture, or -1 if there is no particular limit.

Returns 0 if cube map textures are not supported.

The value returned may not be meaningful until after the graphics context has been fully created (e.g. the window has been opened).

int getMaximumSimultaneousRenderTargets | ( |  | ) |

Returns the maximum simultaneous render targets supported.

int getMaxLights | ( |  | ) |

Returns the maximum number of simultaneous lights that may be rendered on geometry, or -1 if there is no particular limit.

The value returned may not be meaningful until after the graphics context has been fully created (e.g. the window has been opened).

int getMaxTextureStages | ( |  | ) |

Returns the maximum number of simultaneous textures that may be applied to geometry with multitexturing, as supported by this particular GSG.

If you exceed this number, the lowest-priority texture stages will not be applied. Use TextureStage.set_priority() to adjust the relative importance of the different texture stages.

The value returned may not be meaningful until after the graphics context has been fully created (e.g. the window has been opened).

int getMaxVertexTransformIndices | ( |  | ) |

Returns the maximum number of transforms there may be in a single TransformTable for this graphics hardware.

If this number is 0 (but get_max_transforms() is nonzero), then the graphics hardware (or API) doesn't support indexed transforms, but can support direct transform references.

The value returned may not be meaningful until after the graphics context has been fully created (e.g. the window has been opened).

int getMaxVertexTransforms | ( |  | ) |

Returns the maximum number of transform matrices that may be simultaneously used to transform any one vertex by the graphics hardware.

If this number is 0, then the hardware (or the graphics backend) doesn't support soft-skinned vertices (in which case Panda will animate the vertices in software).

The value returned may not be meaningful until after the graphics context has been fully created (e.g. the window has been opened).

GraphicsPipe getPipe | ( |  | ) |

Returns the graphics pipe on which this GSG was created.

PreparedGraphicsObjects getPreparedObjects | ( |  | ) |

Returns the set of texture and geom objects that have been prepared with this GSG (and possibly other GSG's that share objects).

PyObject getPreparedTextures | ( |  | ) |

Returns a Python list of all of the currently-prepared textures within the GSG.

bool getRuntimeColorScale | ( |  | ) |

Returns true if this particular GSG can implement (or would prefer to implement) set color and/or color scale directly, without requiring any munging of vertices or tricks with lighting.

SceneSetup getScene | ( |  | ) |

Returns the current SceneSetup object.

int getShaderModel | ( |  | ) |

Returns the ShaderModel.

bool getSupports2dTextureArray | ( |  | ) |

Returns true if this GSG can render 2-d textures array.

bool getSupports3dTexture | ( |  | ) |

Returns true if this GSG can render 3-d (volumetric) textures.

bool getSupportsBasicShaders | ( |  | ) |

Returns true if this particular GSG supports arbfp1+arbvp1 or above.

bool getSupportsCgProfile | ( | string | name | ) |

Returns true if this particular GSG supports the specified Cg Shader Profile.

bool getSupportsCompressedTexture | ( |  | ) |

Returns true if this GSG can compress textures as it loads them into texture memory, and/or accept pre-compressed textures for storing.

bool getSupportsCubeMap | ( |  | ) |

Returns true if this GSG can render cube map textures.

bool getSupportsDepthStencil | ( |  | ) |

Returns true if this particular GSG supports textures whose format is F_depth_stencil.

This only returns true if the GSG supports the full packed depth-stencil functionality.

bool getSupportsDepthTexture | ( |  | ) |

Returns true if this particular GSG supports textures whose format is F_depth_stencil.

This returns true if the GSG supports GL_DEPTH_COMPONENT textures, which are considered a limited but still valid case of F_depth_stencil.

bool getSupportsGenerateMipmap | ( |  | ) |

Returns true if this particular GSG can generate mipmaps for a texture automatically, or if they must be generated in software.

If this is true, then mipmaps can safely be enabled for rendered textures (e.g. using the MultitexReducer).

bool getSupportsGeometryInstancing | ( |  | ) |

Returns true if this particular GSG supports hardware geometry instancing: the ability to render multiple copies of a model.

In OpenGL, this is done using the EXT_draw_instanced extension.

bool getSupportsGlsl | ( |  | ) |

Returns true if this particular GSG supports GLSL shaders.

bool getSupportsStencil | ( |  | ) |

Returns true if this particular GSG supports stencil buffers at all.

bool getSupportsTexNonPow2 | ( |  | ) |

Returns true if this GSG can handle non power of two sized textures.

bool getSupportsTextureCombine | ( |  | ) |

Returns true if this particular GSG can use the TextureStage.M_combine mode, which includes all of the texture blend modes specified by set_combine_rgb() and/or set_combine_alpha().

If this is false, you must limit yourself to using the simpler blend modes.

bool getSupportsTextureDot3 | ( |  | ) |

Returns true if this GSG can use the TextureStage.CM_dot3_rgb or CM_dot3_rgba combine modes.

bool getSupportsTextureSavedResult | ( |  | ) |

Returns true if this GSG can use the TextureStage.CS_last_saved_result source, which allows you to save the result of a TextureStage and re-use it for multiple inputs.

bool getSupportsTwoSidedStencil | ( |  | ) |

Returns true if this particular GSG supports two sided stencil: different stencil settings for the front and back side of the same polygon.

QualityLevel getTextureQualityOverride | ( |  | ) |

Returns the global quality_level override specified by set_texture_quality_override.

This is mainly useful for the tinydisplay software renderer. See Texture.set_quality_level().

GraphicsThreadingModel const getThreadingModel | ( |  | ) |

Returns the threading model that was used to create this GSG.

bool isActive | ( |  | ) |

Returns the active flag associated with the GraphicsStateGuardian.

bool isHardware | ( |  | ) |

Returns true if this GSG appears to be hardware-accelerated, or false if it is known to be software only.

bool isValid | ( |  | ) |

Returns true if the GSG has been correctly initialized within a graphics context, false if there has been some problem or it hasn't been initialized yet.

bool needsReset | ( |  | ) |

Returns true if the gsg is marked as needing a reset.

releaseAll | ( |  | ) |

Releases all prepared objects.

int releaseAllGeoms | ( |  | ) |

Frees the resources for all geoms associated with this GSG.

int releaseAllIndexBuffers | ( |  | ) |

Frees the resources for all index buffers associated with this GSG.

int releaseAllTextures | ( |  | ) |

Frees the resources for all textures associated with this GSG.

int releaseAllVertexBuffers | ( |  | ) |

Frees the resources for all vertex buffers associated with this GSG.

restoreGamma | ( |  | ) |

Restore original gamma setting.

setActive | ( | bool | active | ) |

Sets the active flag associated with the GraphicsStateGuardian.

If the GraphicsStateGuardian is marked inactive, nothing is rendered. This is not normally turned off unless there is a problem with the rendering detected at a low level.

setCoordinateSystem | ( | CoordinateSystem | cs | ) |

Changes the coordinate system in effect on this particular gsg.

This is also called the "external" coordinate system, since it is the coordinate system used by the scene graph, external to to GSG.

Normally, this will be the default coordinate system, but it might be set differently at runtime.

setFlashTexture | ( | Texture | tex | ) |

Sets the "flash texture".

This is a debug feature; when enabled, the specified texture will begin flashing in the scene, helping you to find it visually.

The texture also flashes with a color code: blue for mipmap level 0, yellow for mipmap level 1, and red for mipmap level 2 or higher (even for textures that don't have mipmaps). This gives you an idea of the choice of the texture size. If it is blue, the texture is being drawn the proper size or magnified; if it is yellow, it is being minified a little bit; and if it red, it is being minified considerably. If you see a red texture when you are right in front of it, you should consider reducing the size of the texture to avoid wasting texture memory.

Not all rendering backends support the flash_texture feature. Presently, it is only supported by OpenGL.

bool setGamma | ( | float | gamma | ) |

Set gamma.

Returns true on success.

setIncompleteRender | ( | bool | incomplete_render | ) |

Sets the incomplete_render flag.

When this is true, the frame will be rendered even if some of the geometry or textures in the scene are not available (e.g. they have been temporarily paged out). When this is false, the frame will be held up while this data is reloaded.

Setting this true allows for a smoother frame rate, but occasionally parts of the frame will be invisible or missing (they will generally come in within a second or two). Setting this false guarantees that every frame will be complete, but may cause more chugs as things are loaded up at runtime.

You may want to set this false during loading screens, to guarantee that all of your assets are available by the time you take the loading screen down.

This flag may also be set individually on each DisplayRegion. It will be considered true for a given DisplayRegion only if it is true on both the GSG and on the DisplayRegion.

setLoader | ( | PandaLoader | loader | ) |

Sets the Loader object that will be used by this GSG to load textures when necessary, if get_incomplete_render() is true.

bool setScene | ( | SceneSetup | scene_setup | ) |

Sets the SceneSetup object that indicates the initial camera position, etc.

This must be called before traversal begins. Returns true if the scene is acceptable, false if something's wrong. This should be called in the draw thread only.

setShaderModel | ( | int | shader_model | ) |

Sets the ShaderModel.

This will override the auto- detected shader model during GSG reset. Useful for testing lower-end shaders.

setTextureQualityOverride | ( | QualityLevel | quality_level | ) |

Specifies the global quality_level to be imposed for all Textures rendered by this GSG.

This overrides the value set on individual textures via Texture.set_quality_level(). Set this to Texture.QL_default in order to allow the individual texture quality levels to be respected.

This is mainly useful for the tinydisplay software renderer. See Texture.set_quality_level().

All Classes Namespaces Functions Variables Enumerations Enumerator Properties